
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java虚拟机体系结构深入研究总结 / iVAN</title>

    <meta name="description" content="Java虚拟机体系结构深入研究总结 工作以来,代码越写越多,程序也越来越臃肿,效率越来越低,对于我这样一个追求完美的程序员来说,这是绝对不被允许的,于是除了不断优化程序结构外,内存优化和性能调优就成了我惯用的&quot;伎俩&quot;. 要对Java程序进行内存优化和性能调优,不了解虚拟机的内部原理(或者叫规范更严谨一点)是肯定不行的,这里推荐一本好书&lt;深入Java虚拟机 (第二版)&gt;(Bill Venners著,曹晓刚 蒋靖 译,实际上本文正是作者阅读本书之后,对Java虚拟机的个人理解阐述).当然了,了解Java ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Java虚拟机体系结构深入研究总结</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>工作以来，代码越写越多，程序也越来越臃肿，效率越来越低，对于我这样一个追求完美的程序员来说，这是绝对不被允许的，于是除了不断优化程序结构外，内存优化和性能调优就成了我惯用的“伎俩”。</p>
<p>要对Java程序进行内存优化和性能调优，不了解虚拟机的内部原理(或者叫规范更严谨一点)是肯定不行的，这里推荐一本好书《深入Java虚拟机<br />
(第二版)》(Bill Venners著，曹晓刚 蒋靖<br />
译，实际上本文正是作者阅读本书之后，对Java虚拟机的个人理解阐述)。当然了，了解Java虚拟机的好处并不仅限于上述两点好处。从更深一点的技术层</p>
<p>面上看，了解Java虚拟机的规范和实现，将更加有助于我们编写高效、稳定的Java代码。比如，假如了解Java虚拟机的内存模型，了解虚拟机的内存回</p>
<p>收机制，那么我们就不会过分依赖它，而会在需要的时候显式的”释放内存”(Java代码不能显式释放内存，但是可以通过释放对象引用告知垃圾回收器回收该</p>
<p>对象需要被回收)，以降低不必要的内存消耗；假如我们了解Java栈的工作原理，那么我们就可以通过减少递归层数，减少循环次数来降低堆栈溢出的风险。可</p>
<p>能对于应用开发人员来说，可能不会直接去涉及这些Java虚拟机底层实现的工作，但是了解这些背景知识，或多或少，都会对我们写的程序产生潜移默化的好的<br />
 影响。</p>
<p>本篇文章，将简明扼要的说明Java虚拟机的体系结构和内存模型，如有用词不妥或解释不准确之处，请不吝指正，深感荣幸!</p>
<p><strong>Java 虚拟机体系结构</strong></p>
<p><a href="http://s3.51cto.com/wyfs02/M02/7C/B5/wKiom1bWkhfQErbyAABk5SfoLAk816.jpg-wh_651x-s_655627383.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvN0MvQjUvd0tpb20xYldraGZRRXJieUFBQms1U2ZvTEFrODE2LmpwZy13aF82NTF4LXNfNjU1NjI3MzgzLmpwZw==.jpg"></a></p>
<p><strong>类装载子系统</strong></p>
<p>Java虚拟机有两种类装载器，分别是启动类装载器和用户自定义装载器。</p>
<p>通类装载子系统通过类的全限定名（包名和类名，网络装载还包括 URL）将 Class<br />
装载进运行时数据区。对于每一个被装载的类型，Java虚拟机都会创建一个java.lang.Class类的实例来代表该类型，该实例被放在内存中的堆<br />
 区，而装载的类型信息则位于方法区，这一点和所有其他对象都是一样的。</p>
<p>类装载子系统在装载一个类型前，除了要定位和导入对应的二进制class文件外，还要验证导入类的正确性，为类变量分配并初始化内存，以及解析符号引用为直接引用，这些动作严格按照以下顺序进行：</p>
<p>1）装载——查找并装载类型的二进制数据；</p>
<p>2）连接——执行验证，准备以及解析(可选)</p>
<p>3）验证 确保被导入类型的正确性</p>
<p>4）准备 为类变量分配内存，并将其初始化为默认值</p>
<p>5）解析 把类型中的符号引用转换为直接应用</p>
<p><strong>方法区</strong></p>
<p>对于每一个被类装载子系统装载的类型，虚拟机都会保存下列数据到方法区：</p>
<ul>
<li>类型的全限定名</li>
<li>类型超类的全限定名(java.lang.Object没有超类)</li>
<li>类型是类类型还是接口类型</li>
<li>类型的访问修饰符</li>
<li>任何直接超接口的全限定名有序列表</li>
</ul>
<p>除了上述基本类型信息，还将保存如下信息：</p>
<ul>
<li>类型的常量池</li>
<li>字段信息(包括字段名、字段类型、字段修饰符)</li>
<li>方法信息(包括方法名、返回类型、参数的数量和类型、方法修饰符，如果方法不是抽象和本地的，还将保存方法的字节码、操作数栈和该方法栈帧中的局部变量区的大小和异常表)</li>
<li>常量以外的所有类变量(其实就是类的静态变量，因为静态变量是所有实例共享的，且与类型直接相关，所以他们是类一级的变量，作为类的成员被保存在方法区)</li>
</ul>
<p><strong>一个到类ClassLoader的引用</strong></p>
<p>//返回的就是刚才保存的ClassLoader引用   <br />
String.class.getClassLoader();</p>
<p><strong>一个到Class类的引用</strong></p>
<p>//将返回刚才保存的Class类的引用   <br />
String.class;</p>
<p>注意，方法区也是可以被垃圾回收器回收的。</p>
<p><strong>堆</strong></p>
<p>Java程序在运行时创建的所有类实例或数组都放在同一个堆中，而每一个Java虚拟机也是有一个对空间，所有线程共享一个堆(这就是一个多线程的Java程序会产生对象访问的同步问题的原因了)。</p>
<p>由于每一种Java虚拟机都有对虚拟机规范的不同实现，所以我们可能不知道每一种Java虚拟机在堆中是以何种形式表示对象实例的，不过我们可以通过下面这可能的实现来一窥端倪：</p>
<p><a href="http://s3.51cto.com/wyfs02/M00/7C/B5/wKiom1bWkj2zM0YuAAC6mr3Wrwo021.jpg-wh_600x-s_2635048785.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvN0MvQjUvd0tpb20xYldrajJ6TTBZdUFBQzZtcjNXcndvMDIxLmpwZy13aF82MDB4LXNfMjYzNTA0ODc4NS5qcGc=.jpg"></a></p>
<p>程序计数器</p>
<p>对于运行中的Java程序而言，每一个线程都有自己的PC（程序计数器）寄存器，它是在该线程启动时创建的，大小为一个字长，用来保存需要被执行的下一行代码的位置。</p>
<p>Java栈</p>
<p>每一个线程都有一个Java栈，以栈帧为单位保存线程的运行状态。虚拟机对Java栈的操作有两种：压栈和出栈，二者都已帧为单位。栈帧保存了传入参数、局部变量、中间运算结果等数据，在方法完成时被弹出，然后释放。</p>
<p>看一下两个局部变量相加时栈帧的内存快照</p>
<p><a href="http://s3.51cto.com/wyfs02/M00/7C/B4/wKioL1bWksejOxeYAABPqZJFsz8293.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvN0MvQjQvd0tpb0wxYldrc2VqT3hlWUFBQlBxWkpGc3o4MjkzLmpwZw==.jpg"></a></p>
<p><strong>本地方法栈</strong></p>
<p>这是 Java 调用操作系统本地库的地方，用来实现 JNI（Java Native Interface，Java 本地接口）</p>
<p><strong>执行引擎</strong></p>
<p>Java虚拟机的核心，控制装入 Java 字节码并解析；对于运行中的Java程序而言，每一个线程都是一个独立的虚拟机执行引擎的实例，从线程生命周期的开始到结束，他要么在执行字节码，要么在执行本地方法。</p>
<p><strong>本地接口</strong></p>
<p>连接了本地方法栈和操作系统库。</p>
<p>注:文中所有提到”Java虚拟机”的地方都是指”JavaEE和JavaSE平台的Java虚拟机规范”。</p>
<p>来源：51CTO</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 08:08:12</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/%e5%a4%9a%e7%ba%bf%e7%a8%8b/" title="多线程">多线程</a>, <a href="https://www.iamivan.net/tag/class/" title="class">class</a>, <a href="https://www.iamivan.net/tag/%e5%86%85%e5%ad%98%e6%a8%a1%e5%9e%8b/" title="内存模型">内存模型</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Java虚拟机体系结构深入研究总结的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7yAKz.html" rel="bookmark">Java虚拟机体系结构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JAVA虚拟机的生命周期 一个运行时的Java虚拟机实例的天职是:负责运行一个java程序.当启动一个Java程序时,一个虚拟机实例也就诞生了.当该程序关闭退出,这个虚拟机实例也就随之消亡.如果同一台计算机上同时运行三个Java程序,将得到三个Java虚拟机实例.每个Java程序都运行于它自己的Java虚拟机实例中. Java虚拟机实例通过调用某个初始类的main()方法来运行一个Java程序.而这个main()方法必须是共有的(public).静态的(static).返回值为void,并且接受			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJkJe8b.html" rel="bookmark">理解Java虚拟机体系结构（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 概述 众所周知,Java支持平台无关性.安全性和网络移动性.而Java平台由Java虚拟机和Java核心类所构成,它为纯Java程序提供了统一的编程接口,而不管下层操作系统是什么.正是得益于Java虚拟机,它号称的&quot;一次编译,到处运行&quot;才能有所保障. 1.1 Java程序执行流程 Java程序的执行依赖于编译环境和运行环境.源码代码转变成可执行的机器代码,由下面的流程完成: Java技术的核心就是Java虚拟机,因为所有的Java程序都在虚拟机上运行.Java程序的运行需要Java			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwl4Gkb.html" rel="bookmark">Java虚拟机结构基础研究之一</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JVM执行的对象就是大家非常熟悉的class文件,我们也称为类文件,JVM规范定义的这个编译完成的代码文件(虽然并非强制要求是实际的文件)的格式非常的详实,但是我们这里只说一些宏观的内容,以后有机会再研究细节的内容吧.JVM要求的类文件的格式是和硬件和操作系统无关的一种二进制格式,它精确定义了类或者接口的表示,它甚至包含了字节顺序这样的细节,而字节顺序在特定平台的目标文件格式中一般都是固定的,不会进行说明. JVM所支持的数据类型和Java语言规范中定义的几乎一样,请注意是几乎一样!也就是原始类			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNEVl4b.html" rel="bookmark">Java虚拟机结构基础研究之二</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				通过上一篇文章的介绍我们了解了JVM中数据类型以及数据区的知识,这篇我们会通过对JVM堆栈的帧的详细介绍了解方法执行的一些内幕. 帧通常用于存储数据和部分结果,同时还用于执行动态链接.返回方法的返回值以及分发异常. 帧在方法调用的时候被创建,在方法完成的时候销毁.它是在创建它的线程的JVM堆栈中分配到空间的,每个帧都有它自己的局部变量数组.操作数堆栈和一个当前方法所在的类的运行时常量池的引用. 它的局部变量数组和操作数堆栈的大小是在编译的时候就确定了的,而且它是和它所联系的方法的代码一起提供的,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5RWvaz.html" rel="bookmark">深入Java虚拟机之虚拟机体系结构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				工作以来,代码越写越多,程序也越来越臃肿,效率越来越低,对于我这样一个追求完美的程序员来说,这是绝对不被允许的,于是除了不断优化程序结构外,内存优化和性能调优就成了我惯用的&quot;伎俩&quot;. 要对Java程序进行内存优化和性能调优,不了解虚拟机的内部原理(或者叫规范更严谨一点)是肯定不行的,这里推荐一本好书&lt;深入Java虚拟机(第二版)&gt;(Bill Venners著,曹晓刚 蒋靖 译,实际上本文正是作者阅读本书之后,对Java虚拟机的个人理解阐述).当然了,了解Java虚拟机的好处			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJZ52qz.html" rel="bookmark">《深入解析Android 虚拟机》&mdash;&mdash;2&period;2　Java虚拟机概述</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.2 Java虚拟机概述 Java虚拟机(JVM)是一个虚构出来的计算机,是通过在实际的计算机上仿真模拟各种计算机功能模拟来实现的.Java虚拟机有自己完善的硬件架构,如处理器.堆栈.寄存器等,还具有相应的指令系统.JVM虚拟机的运作结构如图2-1所示. 从该图中可以看到,JVM是运行在操作系统之上的,与硬件没有直接的交互.JVM的具体组成部分如图2-2所示. (1)使用JVM的原因. Java语言的一个非常重要的特点就是与平台的无关性.而使用JVM是实现这一特点的关键.一般的高级语言如果要在			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Myde1kb.html" rel="bookmark">理解Android虚拟机体系结构&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 什么是Dalvik虚拟机 Dalvik是Google公司自己设计用于Android平台的Java虚拟机,它是Android平台的重要组成部分,支持dex格式(Dalvik Executable)的Java应用程序的运行.dex格式是专门为Dalvik设计的一种压缩格式,适合内存和处理器速度有限的系统.Google对其进行了特定的优化,使得Dalvik具有高效.简洁.节省资源的特点.从Android系统架构图知,Dalvik虚拟机运行在Android的运行时库层. 2 Dalvik虚拟机的功能			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boKdEXb.html" rel="bookmark">理解Android虚拟机体系结构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 什么是Dalvik虚拟机 Dalvik是Google公司自己设计用于Android平台的Java虚拟机,它是Android平台的重要组成部分,支持dex格式(Dalvik Executable)的Java应用程序的运行.dex格式是专门为Dalvik设计的一种压缩格式,适合内存和处理器速度有限的系统.Google对其进行了特定的优化,使得Dalvik具有高效.简洁.节省资源的特点.从Android系统架构图知,Dalvik虚拟机运行在Android的运行时库层. 2. Dalvik虚拟机的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr2DAjM.html" rel="bookmark">深入解析java虚拟机&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java虚拟机是什么 &quot;java虚拟机&quot;可能指以下三种东西:1).抽象规范:2).一个具体的实现:3).一个运行中的虚拟机实例: java虚拟机生命周期 启动当启动一个java程序时,一个虚拟机实例诞生.虚拟机实例通过调用某个初始类的public static void main(String[] args)方法来运行一个java程序.任何拥有这样一个main方法的类都可以作为java程序运行的起点,所以必须要告诉虚拟机初始类的名称,整个程序将从它的main方法开始运行.消亡初始类的m			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMRq7Kb.html" rel="bookmark" class="title">麒麟928处理器的性能怎么样？</a>
					<div>
						  麒麟928处理器怎么样?下文将进行麒麟928处理器性能评测,华为荣耀6至尊版搭载的处理器就是麒麟928,那么其性能如何呢?大家可以通过下文来了解哦. 从华为官方公布的情况,麒麟928是目前海思处理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp8Nm9b.html" rel="bookmark" class="title">初学C语言关于运行次数的限制</a>
					<div>
						问题描述 初学C语言关于运行次数的限制 我想要运行完第三次就结束要怎么办(无论猜没猜对) #include #include #include int main() { int a, b; srand ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz4Y9Lb.html" rel="bookmark" class="title">c语言-C语言选择法排序函数的实现问题</a>
					<div>
						问题描述 C语言选择法排序函数的实现问题 我在看C语言程序设计是遇到一个问题,用选择法对数组中的5个整数按由小到大排序 #include int main() { void sort(int arra ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEr0JM.html" rel="bookmark" class="title">javascript 常用代码大全</a>
					<div>
						javascript //打开模式对话框 function doSelectUser(txtId) {       strFeatures=&quot;dialogWidth=500px;dialog ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boPn3M.html" rel="bookmark" class="title">实例学习CSS网页技术的基本语法</a>
					<div>
						css|网页|语法 1. 基本语法 CSS的定义是由三个部分构成:选择符(selector),属性(properties)和属性的取值(value). 基本格式如下: selector {proper ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9Lrdb.html" rel="bookmark" class="title">使用链接服务器执行远程数据库上的存储过程</a>
					<div>
						存储过程|服务器|链接|数据|数据库|执行 --创建链接服务器exec sp_addlinkedserver  'srv_lnk','','SQLOLEDB','远程服务器名或ip地址'exec sp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pL9r0z.html" rel="bookmark" class="title">网站模板优化测试细节分析</a>
					<div>
						模板在优化当中的作用:模板几乎决定了网站内容的布局,决定了我们网站的用户体验.决定了我们网站提供的这些具体功能的位置.所以 说模板非茶的重要.那么我们会做模板是作为一个SEO的基本的要求.这个当然不是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPlmyM.html" rel="bookmark" class="title">学Linq to sql（八）：继承与关系</a>
					<div>
						论坛表结构 为了演示继承与关系,我们创建一个论坛数据库,在数据库中创建三个表: 1.论坛版块分类表 dbo.Categories: 字段名 字段类型 可空 备注 CategoryID int not  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1Znqz.html" rel="bookmark" class="title">Photoshop制作华丽大气的花纹艺术字</a>
					<div>
						  Photoshop制作华丽大气的花纹艺术字          最终效果   1.打开PS软件,按Ctrl + N 新建画布,尺寸如下,然后确定. 2.选择渐变工具,颜色设置如图2,然后由画布中心向 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bElm0oz.html" rel="bookmark" class="title">网易云音乐&OpenCurlyDoubleQuote;个性化推荐&rdquo;的设计改版经验总结</a>
					<div>
						  网易云音乐的&quot;个性化推荐&quot;一直是好评如潮,但很少人注意到,这个功能从诞生到现在已历经了多次改版.在这个迭代过程中,如何优雅地让用户感知到它的功能特色?今天网易云音乐的交互设计师 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1jOjz.html" rel="bookmark" class="title">win7任务栏预览窗口尺寸设置方法</a>
					<div>
						Win7系统不仅功能强大,界面设计也是独具匠心,效果酷炫并且功能丰富.大名鼎鼎的Aero特效功能是Win7系统非常著名的特色之一,它不仅有漂亮的半透明的窗口,而且还提供了Win7任务栏窗口缩略预览功能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjw84b.html" rel="bookmark" class="title">Win8系统微软拼音输入法怎么打全角字符</a>
					<div>
						  其实用过芒果手机自带输入法的朋友很多都觉得微软很懂中国和中文输入.并且在Win8系统自带的输入法的使用体验上,依然能得到不少人的肯定! 不过对于微博小编,需要经常用到&quot;[]&quot;这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRw75kp.html" rel="bookmark" class="title">飞信&lpar;Fetion&rpar;还有哪些功能？</a>
					<div>
						即时共享 您是否想与好友共享您现在的状态?让好友知道您正在通过飞信咪咕音乐欣赏的歌曲,正在进行的飞信游戏,分享彼此的快乐. 您可以通过&quot;系统设置→状态与提醒→即时共享&quot;,打开即时共 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYLLWM.html" rel="bookmark" class="title">Photoshop 7步制作一个热气球</a>
					<div>
						  本教程介绍热气球的快速制作方法.大致流程:先用矩形工具等做出等宽的矩形色块,然后渲染边缘的暗调及中间的高光做出立体感.适当把做的图形球面化后再复制,组合,再变形做出需要的球面即可. 版本要求:需要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZYrvz.html" rel="bookmark" class="title">显卡升级后无法正常安装显卡驱动怎么办</a>
					<div>
						显卡升级后无法正常安装显卡驱动是由于在升级驱动程序前,没有卸载原来的老驱动程序,比如有的用户开始使用的是ATI显卡,而后升级成Nvidia显卡,但当换显卡后,使用过程中系统提示设备有冲突,情况表现为显 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oEqab.html" rel="bookmark" class="title">什么是Haswell&quest;Haswell的新特性介绍</a>
					<div>
						英特尔于 2013年6月4日在2013年第33届台北国际电脑展发布了第四代使用酷睿技术的处理器,代号为&quot;Haswell&quot;.Haswell处理器具备更强大的计算性能,与此同时功耗较此 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGwQWp.html" rel="bookmark" class="title">IE11预览版</a>
					<div>
						伴随着Windows 8预览版发布,IE11预览版也随之到来.此外,微软还在前几天推出了兼容Windows 7操作系统的IE11开发者预览版,目前已有不少下载尝鲜.但据网友反映,使用IE11预览版时发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvr70VM.html" rel="bookmark" class="title">jsp自定义标签-jsp中怎么自定义一个有onclick这样属性的标签啊？</a>
					<div>
						问题描述 jsp中怎么自定义一个有onclick这样属性的标签啊? 哪位大虾可以告诉菜鸟,怎么在自定义的标签中定义一个可以调用jQuery里面方法的属性哇,就像onclick那种. 解决方案 自定义一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxoAl0b.html" rel="bookmark" class="title">【14】GO语言的接口类型</a>
					<div>
						原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://qingkechina.blog.51cto.com/5552198/167511 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQORWz.html" rel="bookmark" class="title">硅谷飘来五个字，SMACK </a>
					<div>
						上次我们跟大家分享了「少打一局王者荣耀就能上手Spring Cloud?!」,学到就是赚到,翘课的同学抓紧补习了.本期为大家带来全新「与硅谷大数据工程师吃着火锅唱着歌就把SMACK入门了」篇. SMA ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDedLlb.html" rel="bookmark" class="title">服务器-Android中如何轮训不耗费大量的流量和电力</a>
					<div>
						问题描述 Android中如何轮训不耗费大量的流量和电力 现在需要写一个轮训,如果服务器有新的数据,一段时间进行查询一下,看是否有新的数据!我知道可以写一个线程去访问!但是有没有更好的方法呢?求大神支 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDJqdz.html" rel="bookmark" class="title">三星A7手机如何安装SD卡？ A7安装内存卡教程</a>
					<div>
						1.如下图所示,我们在手机关机之后我们用用手指轻轻扣住上边的插槽,拆下后盖 要细不要搞坏了.     2 然后我们再把将SD卡推入插槽,直到卡住为止.    注:请确保SD卡的金色触针面朝下和SD卡完 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0k9nM.html" rel="bookmark" class="title">win2003&plus;IIS下安装Xcache加速的配置方法分享&lowbar;win服务器</a>
					<div>
						在论坛后台看了半天,只有内存优化一个还没有做,但是自己以前又没有弄过,只有学了. 论坛支持Memcache.eAccelerator.Alternative PHP Cache(APC).Xcache ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQB7RWM.html" rel="bookmark" class="title">网络 rtp rtcp-RTP乱序情况下 RTCP精确统计loss&lowbar;fraction丢包率</a>
					<div>
						问题描述 RTP乱序情况下 RTCP精确统计loss_fraction丢包率 RTCP统计丢包率loss_fraction方法概述:expected_num=high_seqnum - preHigh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX092lp.html" rel="bookmark" class="title">dhtmlxcombo问题-dhtmlxcombo动态添加选项后，下拉框打不开</a>
					<div>
						问题描述 dhtmlxcombo动态添加选项后,下拉框打不开 利用dhtmlxcombo动态添加选项后,通过combo.getList()查看到数据已经加载进去了,但是下拉列表打不开,这是为什么呢?  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmBNRDz.html" rel="bookmark" class="title">《Unity 3&period;x游戏开发实例》&mdash;&mdash;2&period;11节《Artillery Live&excl;》</a>
					<div>
						2.11 &lt;Artillery Live!&gt; &lt;Artillery Live! &gt;(http://www.gamebrew.com/game/artillery-live/pl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeo1ZVM.html" rel="bookmark" class="title">请求token报错：web&lowbar;application</a>
					<div>
						问题描述 string '{&quot;error&quot;:&quot;web_application&quot;,&quot;timestamp&quot;:1429432407187,&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKNaWM.html" rel="bookmark" class="title">JS控件的生命周期介绍&lowbar;javascript技巧</a>
					<div>
						JS控件的生命周期跟其他平台UI的生命周期类似,但是又有自己的特点,我们只有将控件的生命周期划分清晰,所有的控件编写.mixins的编写和plugin的编写才能遵循控件的生命周期做统一的管理.在这里我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0NdRJz.html" rel="bookmark" class="title">Asp&period;Net Oracle数据的通用操作类&lowbar;实用技巧</a>
					<div>
						在一个项目中,可能用到2种数据,比如说ORACLE ,MS_SQLSERVER 同时要用到,MS-SQL的数据通用类在很多的教程中都有现成的例子和代码,但是ORACLE比较少见,但是本次项目中正好用到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmgvXz.html" rel="bookmark" class="title">五大巨变颠覆微时代</a>
					<div>
						导语:要说微时代的三要素其实就是碎片化.情感营销和体验经济.而只有在理解好这三要素以后,你才能在微时代的营销有可能能够游刃有余. 第一,从流量为王到关系为王. 现在移动互联网时代的意义已经超越了互联网 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
